// A simple spelling checker applet

import java.awt.*;
import java.awt.event.*;

public class SpellChecker extends Frame implements ActionListener
{
    String dictionary[] = new String [100];
    int nWords = 0;

    TextField theInput    = new TextField("", 40);
    Button    checkButton = new Button("Check this word");  
    Button    addButton   = new Button("Add to Dictionary");
    Button    listButton  = new Button("List the dictionary"); 
    TextArea  theOutput   = new TextArea("", 8, 40);

    public SpellChecker() 
    {
    	setLayout(new FlowLayout());
        addWord("aardvark");
        addWord("abacus");
        addWord("algebra");

        add( theInput );
        add( checkButton );
        add( addButton );
        add( listButton );
        add( theOutput );
        
        listButton.addActionListener(this);
        addButton.addActionListener(this);
        checkButton.addActionListener(this);
        
        theOutput.setEditable(false);
        setSize(500,400);
        setVisible(true);
        addWindowListener(new WindowAdapter()
        {
        	public void windowClosing(WindowEvent e)
        	{
        		setVisible(false);
        		System.exit(0);
        	}
        }
        );
    }

    public String toString() 
    {
        String s;
        s = "Dictionary list:\n";
        for (int i = 0; i < nWords; i++) 
        {
            s = s + dictionary[i] + "\n";
        }
        return ( s + "\n" );
    }

    public void actionPerformed( ActionEvent theEvent )
    {
        String word = theInput.getText();

        if ( theEvent.getSource( ) == listButton )
             theOutput.append( "" + this );
        else if ( theEvent.getSource( ) == addButton )
        {
            addWord( word );  
            theOutput.append( "The word : " + word + " has been added.\n" );
        }
        else if ( theEvent.getSource( ) == checkButton )
        {
            theOutput.append( "Your word is " + word + ": " );
            if ( isInDictionary( word ) )
                theOutput.append( "spelled correctly" + "\n" );
            else
                theOutput.append( "Not in the dictionary" + "\n" );
        }
    }

    public void addWord( String word ) 
    {
        if ( nWords > dictionary.length) 
            theOutput.append ("Sorry, the dictionary is full.\n");
        else
        {
            dictionary[nWords] = word;
            nWords++;
        }
    }

    public boolean isInDictionary( String word ) 
    {
        for ( int i = 0; i < nWords; i++ ) 
            if ( word.equals( dictionary[i] ) ) return true;

        return false;
    }
    
    public static void main(String a[])
    {
    	SpellChecker sC = new SpellChecker();
    }
}
