// Definition of Circle2

package shape;

import shape.Point2;

public class Circle2 extends Point2 // inherits from Point2
{
	protected double radius;
	
	// default constructor
	public Circle2()
	{
		// implicit call to superclass constructor
		setRadius(0);
	}
	
	// constructor
	public Circle2(double r,int a, int b)
	{
		super(a,b);  // call the superclass constructor
		setRadius(r);
	}
	
	// Set radius of Circle
	public void setRadius(double r)
	{
		radius = r >= 0.0 ? r : 0.0;
	}
	
	// Get radius of Circle
	public double getRadius()
	{
		return radius;
	}
	
	// Calculate area of Circle
	public double area()
	{
		return Math.PI * radius * radius;
	}
	
	// convert the Circle to a String
	public String toString()
	{
		return "Center = " + super.toString() + "; Radius = " + radius;
	}
}

