// CommissionWorker is a subclass of Employee
public final class CommissionWorker extends Employee
{
	private double salary; // base salary per week
	private double commission;// amount per item sold
	private int quantity; // total items sold per week
	
	// Constructor for class CommissionWorker
	public CommissionWorker(String first,String last,double s,double c,int q)
	{
		super(first,last); // call superclass constructor
		setSalary(s);
		setCommission(c);
		setQuantity(q);
	}
	// Set CommissionWorker's monthly base salary
	public void setSalary(double s)
	{
		salary = s > 0 ? s : 0;
	}
	// set CommissionWorker's commission
	public void setCommission(double d)
	{
		commission = d > 0 ? d :0;
	}
	
	// set CommissionWorker's quantity sold
	public void setQuantity(int q)
	{
		quantity = q > 0 ? q : 0;
	}
	
	// Determine's commissionerWorker's earnings
	public double earnings()
	{
		return salary + commission + quantity;
	}
	// CommissionWorker's name
	public String toString()
	{
		return "Commission worker: " + super.toString();
	}
}