// Definition of class Cylinder

package shape;
import shape.Circle2;

public class Cylinder extends Circle2
{
	protected double height; // height of Cylinder
	
	// No-argument constructor
	public Cylinder()
	{
		// implicit call to superclass constructor here
		setHeight(0);
	}
	
	// constructor
	public Cylinder(double h,double r, int a, int b)
	{
		super(r,a,b);
		setHeight(h);
	}
	
	// Set height of Cylinder
	
	public void setHeight(double h)
	{
		height = h >= 0 ? h : 0;
	}
	
	// get the height of Cylinder
	public double getHeight()
	{
		return height;
	}
	
	// Calculate area of Cylinder 
	public double area()
	{
		 return 2 * super.area() + 2 * Math.PI * radius * height;
		 
	}
	
	// calculate volume of Cylinder
	public double volume()
	{
		return super.area() * height;
	}
	
	// Convert the Cylinder into String
	public String toStrign()
	{
		return super.toString() + "; Height = " + height;
	}
}