import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;


public class AdvancedGraphics2 extends Frame
{
	public AdvancedGraphics2()
	{
		super("Drawing more 2D shapes");
		setSize(400,400);
		setBackground(Color.black);
		show();
	}
	
	public void paint(Graphics g)
	{
		Graphics2D g2d =  (Graphics2D)g;
		
		int xPoints[] = {55,67,109,73,83,55,27,37,1,43};
		int yPoints[] = {0,36,36,54,96,72,96,54,36,36};
		// create a star from a series of points
		GeneralPath star = new GeneralPath();
		
		// set the initial coordinate of the General Path
		
		star.moveTo(xPoints[0],yPoints[0]);
		
		// create the star- theis does not draw the star
		for(int k=1;k<xPoints.length;k++)
		star.lineTo(xPoints[k],yPoints[k]);
		
		// close the shape
		
		star.closePath();
		
		// translate the origin to (200,200)
		
		g2d.translate(200,200);
		
		// rotate around origin and draw stars in random colors
		
		for(int j= 1 ; j<= 20;j++)
		{
			g2d.rotate(Math.PI/10.0);
			g2d.setColor(new Color((int)(Math.random() *256), (int)(Math.random()* 256),(int)(Math.random()*256)));
			g2d.fill(star);
			try
			{
				Thread.sleep(1000);
			}
			catch(InterruptedException e){}
		
		}
		
		
	}
	
	public static void main(String args[])
	{
		AdvancedGraphics2 aG2 = new AdvancedGraphics2();
		aG2.addWindowListener(new LetWindowClose());
	}
}
class LetWindowClose extends WindowAdapter
{
	public void windowClosing(WindowEvent e)
	{
		System.exit(0);
	}
}