import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;


public class RandomRectangles extends Applet implements ActionListener,ItemListener
{
	private static Color [] colors = {Color.white,Color.black,Color.blue,Color.red,Color.yellow,Color.orange,Color.cyan,Color.pink,Color.magenta,Color.green};
	
	private int numRects = 10;
	private boolean fill = false,raise = false,round = false,threeD = false;
	Button rectsButton,roundButton,threeDButton;
	public void init()
	{
		 rectsButton = new Button("Rectangles");
		 roundButton = new Button("Round rectangle");
		 threeDButton = new Button("3D Rectangles");
		
		Checkbox fillCheckbox = new Checkbox("Fill");
		
		add(rectsButton);
		add(roundButton);
		add(threeDButton);
		add(fillCheckbox);
		
		rectsButton.addActionListener(this);
		roundButton.addActionListener(this);
		threeDButton.addActionListener(this);
		fillCheckbox.addItemListener(this);
		
	}
	
	public void actionPerformed(ActionEvent e)
	{
		if(e.getSource() == rectsButton)
		{
			round = false;
			threeD = false;
			repaint();
		}
		
		else if(e.getSource() == roundButton)
		{
			round = true;
			threeD = false;
			repaint();
		}
		
		else
		{
			round = false;
			threeD = true;
			repaint();
		}
	}
	
	public void itemStateChanged(ItemEvent e)
	{
		fill = ((Checkbox)(e.getSource())).getState();
	}
	
	public void paint(Graphics g)
	{
		for(int i= 0;i<numRects;i++)
		{
			Point lefthc = randomPoint();// Left hand conrner
			Dimension size = randomDimension();
			
			g.setColor(colors[(int)(Math.random() * 10)]);
			
			if(round)
			{
				if(fill)
				g.fillRoundRect(lefthc.x,lefthc.y,size.width,size.height,(int)(Math.random() * 250),(int)(Math.random() * 250));
				
				else
				g.drawRoundRect(lefthc.x,lefthc.y,size.width,size.height,(int)(Math.random() * 250),(int)(Math.random() * 250));
				
			}
			
			else if(threeD)
			{
				g.setColor(Color.lightGray);
				if(fill)
				g.fill3DRect(lefthc.x,lefthc.y,size.width,size.height,raise);
				else
				g.draw3DRect(lefthc.x,lefthc.y,size.width,size.height,raise);
			}
			
			else
			{
				if(fill)
				g.fillRect(lefthc.x,lefthc.y,size.width,size.height);
				else
				g.drawRect(lefthc.x,lefthc.y,size.width,size.height);
			}
			
			raise = raise?false:true;
		}
	}
	
	private Dimension randomDimension()
	{
		return new Dimension((int)(Math.random() * 250),(int)(Math.random() * 250));
	}
	
	private Point randomPoint()
	{
		return new Point((int)(Math.random() * 250),(int)(Math.random() * 250));
	}
}