class Monitor
{
  int n;
  boolean valueset = false;
  
  synchronized int get()
  {
    if(!valueset)
    try
    {
      wait();
    }
    catch(InterruptedException e)
    {
      System.out.println("InterruptedException caught");
    }
    System.out.println("Got:"+n);
    valueset = false;
    notify();
    return n;
  }
  
  synchronized void put(int n)
  {
    if(valueset)
    try
    {
      wait();
    }
    catch(InterruptedException e)
    {
      System.out.println("InterruptedException caught");
    }
    this.n = n;
    valueset = false;
    System.out.println("Put:"+n);
    notify();
  }
}

class ProducerThread implements Runnable
{
  Monitor mon;
  
  ProducerThread(Monitor mon)
  {
    this.mon = mon;
    new Thread(this, "Producer").start();
  }
  
  public void run()
  {
    int i = 0;
    while(true)
    {
      mon.put(i++);
    }
  }
}      	  		 

class ConsumerThread implements Runnable
{
  Monitor mon;
  
  ConsumerThread(Monitor mon)
  {
    this.mon = mon;
    new Thread(this, "Consumer").start();
  }
  
  public void run()
  {
    while(true)
    {
      mon.get();
    }
  }
}

public class ProducerConsumer
{
  public static void main(String args[])
  {
    Monitor mon = new Monitor();
    new ProducerThread(mon);
    new ConsumerThread(mon);
    
    System.out.println("Press Ctrl-C to stop");
  }
}          	  		       	  			